# -*- coding: utf-8 -*-
"""
Created on Fri Jan 19 01:11:38 2024

@author: cawang
"""
import numpy as np
import matplotlib.pyplot as plt


#%%
def twoQeigs_v1(e, tc, ty, fq1, fq2, evec_ref=np.eye(6)):
    sq2 = np.sqrt(2)
    U = 600 #2.56e-3*1.602e-19 / (1e9*6.62e-34)

    evs = np.zeros((6,))
    evecs = np.zeros((6,6,),dtype=complex)          

    dEz = (fq2 - fq1)/2e3
    sEz = (fq2 + fq1)/2e3

    tz, tx= 0, 0
    H = np.array([[       U+e,           0, -ty+1j*tx,  sq2*tc, -1j*sq2*tz, -ty-1j*tx],
                  [         0,         U-e, -ty+1j*tx,  sq2*tc, -1j*sq2*tz, -ty-1j*tx],
                  [ -ty-1j*tx,   -ty-1j*tx,       sEz,       0,          0,         0],
                  [    sq2*tc,      sq2*tc,         0,       0,        dEz,         0],
                  [ 1j*sq2*tz,   1j*sq2*tz,         0,     dEz,          0,         0],
                  [ -ty+1j*tx,   -ty+1j*tx,         0,       0,          0,      -sEz],
    ]) 

    ev, evec = np.linalg.eigh(H)
    evs = np.real(ev)
    evec_new = np.zeros_like(evec)
    for j in range(6):
        temp_var = evec[:,j].copy()
        
        if np.sum( np.abs(temp_var-evec_ref[:,j])**2  ) > np.sum( np.abs(-temp_var-evec_ref[:,j])**2  ) :
            # print(temp_var, evec_ref[:,j])
            temp_var *= -1
        evec_new[:,j]  = temp_var.copy()
    evecs[:,:] = evec_new  
    return evs, np.real(evecs)




#%%
eee0 = np.concatenate((np.linspace(-800, 580, 501),
                       np.linspace(580, 620, 1001),
                      np.linspace(620, 800, 201)))

t_c = 0.4
t_so = 0.2
plt.figure()
plt.subplots_adjust(wspace=0.3, hspace=0.3)

p1 = np.array([0, 0, 1100, 900])
evs = np.array([twoQeigs_v1( e, *p1)[0] for e in eee0]).reshape(len(eee0),6).T
plt.subplot(221)
for i in range(6):
    plt.plot(eee0, evs[i,:],'k' , linewidth=1 )
plt.xticks([-600, 0, 600])







plt.subplot(222)
p1 = np.array([0, 0, 1100, 900])
evs = np.array([twoQeigs_v1( e, *p1)[0] for e in eee0]).reshape(len(eee0),6).T
for i in range(6):
    plt.plot(eee0, evs[i,:],'r', linewidth=1)

p1 = np.array([t_c, 0, 1100, 900])
evs = np.array([twoQeigs_v1( e, *p1)[0] for e in eee0]).reshape(len(eee0),6).T
for i in range(6):
    plt.plot(eee0, evs[i,:],'b-', linewidth=1 )
    
plt.xlim(595, 605)
plt.xticks([595, 600, 605])
plt.ylim(-2,2)




plt.subplot(223)

p1 = np.array([t_c, 0, 1100, 900])
evs = np.array([twoQeigs_v1( e, *p1)[0] for e in eee0]).reshape(len(eee0),6).T
for i in range(6):
    plt.plot(eee0, evs[i,:],'b-', linewidth=1 )
    
p1 = np.array([t_c, t_so, 1100, 900])
evs = np.array([twoQeigs_v1( e, *p1)[0] for e in eee0]).reshape(len(eee0),6).T
for i in range(6):
    plt.plot(eee0, evs[i,:],'b--', linewidth=1 )
plt.xlim(595, 605)
plt.xticks([595, 600, 605])
plt.ylim(-2,2)





plt.subplot(224)

p1 = np.array([t_c, 0, 55, 45])
evs = np.array([twoQeigs_v1( e, *p1)[0] for e in eee0]).reshape(len(eee0),6).T
for i in range(6):
    plt.plot(eee0, evs[i,:],'b-', linewidth=1 )
    
p1 = np.array([t_c, t_so, 55, 45])
evs = np.array([twoQeigs_v1( e, *p1)[0] for e in eee0]).reshape(len(eee0),6).T
for i in range(6):
    plt.plot(eee0, evs[i,:],'b--', linewidth=1 )
plt.xlim(570, 630)
plt.xticks([570, 600, 630])
plt.ylim(-0.2,0.2)





#filename = 'Fig2-4-bcde'
#plt.savefig(filename+'.pdf')


