# this file is modified from Supp/uneuql_time/bloch_slider_without_qutip_v3_q1x90.py
import matplotlib.pyplot as plt
from matplotlib.widgets import Slider, Button
import numpy as np
import scipy.linalg
sx = np.array([[0,1],[1,0]],dtype=complex)
sy = np.array([[0,-1j],[1j,0]],dtype=complex)
sz = np.array([[1,0],[0,-1]],dtype=complex)
sm = np.array([[0,0],[1,0]],dtype=complex)



from my_bloch import Bloch
def expect(M, ss):
    if isinstance(ss, list):
        slist = []
        for ssx in ss:
            s = ssx.reshape(-1)
            slist += [  np.real(np.dot(s.conj(), M @ s))  ]
        return slist
    else:
        s = ss.reshape(-1)
        return np.real(np.dot(s.conj(), M @ s))

#%%
def state2vec(s):
    return expect(sx, s), expect(sy, s), expect(sz, s)

sphere_static = None
if sphere_static==None:
    pltname = f'Supp_q1x90_equal'
    fig = plt.figure( pltname, figsize = (7,9))
    sphere_static=Bloch(fig)
else:
    sphere_static.clear()

sphere_static.zlabel = [r'$\left|\uparrow\right>$', r'$\left|\downarrow\right>$' ]
sphere_static.vector_color = ['g']*3



Omega = 0.05
fd = 1

fq2 = 1.0
dt = 0.01

psi00 = np.array([[1],[1]], dtype=complex) /np.sqrt(2)
# sphere_static.add_states( state2vec(psi00) )
for i in range(501):
    n = i + 0.5
    H2 = (fq2/2) *  sz + Omega*sx * np.cos(2*np.pi*fd*n*dt -  0.5*np.pi )
    dU2 = scipy.linalg.expm(  -2*np.pi*1j* H2 * dt  )
    # Ur = scipy.linalg.expm(  -2*np.pi*1j* ((fd)/2) *  sz * n*dt  )
    if i != 500:
        sphere_static.add_line(  state2vec(  psi00), state2vec( dU2 @ psi00)  , fmt='k' , linewidth=1 )
    
    if i in [0, 100, 200, 300, 400, 500]:
    # if i in [0, 10, 20, 100, 200,]:
        sphere_static.add_states( state2vec(psi00) )
    
    psi00 = dU2 @ psi00
    
    
    


sphere_static.render()

filename = 'Fig2-6-a' 
plt.savefig(filename+'.pdf')


#%%
def state2vec(s):
    return expect(sx, s), expect(sy, s), expect(sz, s)

sphere_static = None
if sphere_static==None:
    pltname = f'Supp_q1x90_equal'
    fig = plt.figure( pltname, figsize = (7,9))
    sphere_static=Bloch(fig)
else:
    sphere_static.clear()

sphere_static.zlabel = [r'$\left|\uparrow\right>$', r'$\left|\downarrow\right>$' ]
sphere_static.vector_color = ['g']*3



Omega = 0.05
fd = 1

fq2 = 1.0
dt = 0.01

psi00 = np.array([[1],[1]], dtype=complex) /np.sqrt(2)
# sphere_static.add_states( state2vec(psi00) )
for i in range(501):
    n = i + 0.5
    H2 = (fq2/2) *  sz + Omega*sx * np.cos(2*np.pi*fd*n*dt -  0.5*np.pi )
    dU2 = scipy.linalg.expm(  -2*np.pi*1j* H2 * dt  )
    Ur = scipy.linalg.expm(  -2*np.pi*1j* ((-fd)/2) *  sz * i*dt  )
    
    Urnew = scipy.linalg.expm(  -2*np.pi*1j* ((-fd)/2) *  sz * (i+1)*dt  )
    if i != 500:
        sphere_static.add_line(  state2vec( Ur @ psi00), state2vec( Urnew @ dU2 @ psi00)  , fmt='k' , linewidth=1 )
    
    if i in [0, 100, 200, 300, 400, 500]:
    # if i in [0, 10, 20, 100, 200,]:
        sphere_static.add_states( state2vec(psi00) )
    
    psi00 = dU2 @ psi00
    
    
    


sphere_static.render()

filename = 'Fig2-6-b' 
plt.savefig(filename+'.pdf')


