import os
path=str(os.getcwd())
path_notebook=str(os.getcwd())
path_notebook=path_notebook.replace('\\Fig8-1-b','')
import sys
sys.path.insert(1, path_notebook)
import helper_functions
from helper_functions import data1d_attr, data2d_attr, data_setvaribles, hist_auto_su, hist_auto_1d



import numpy as np
import matplotlib.pyplot as plt
from projects.notebook_tools.notebook_tools import get_data_from, fit_data
from matplotlib import cm
from matplotlib.colors import ListedColormap, LinearSegmentedColormap
import datetime
import qtt
import sys
import glob
from qcodes.data.data_set import load_data




#%% Estimate readout visibility by averaging

plt.rcParams.update({'font.size':15})
datadir = os.getcwd()  



start_time = [    
                '\\2023-09-01\\12-12-08_sweep1D_waittime_END_q2x90_0_times_rotate_q1' ,   
                '\\2023-09-01\\12-15-51_sweep1D_waittime_END_q2x90_1_times_rotate_q1' ,   
                '\\2023-09-01\\12-19-36_sweep1D_waittime_END_q2x90_2_times_rotate_q1' , 
                '\\2023-09-01\\12-23-21_sweep1D_waittime_END_q2x90_3_times_rotate_q1' , 
                '\\2023-09-01\\12-27-08_sweep1D_waittime_END_q2x90_4_times_rotate_q1' , 
                '\\2023-09-01\\12-30-54_sweep1D_waittime_END_q2x90_5_times_rotate_q1' , 
                '\\2023-09-01\\12-43-50_sweep1D_waittime_END_q2x90_6_times_rotate_q1' , 
                '\\2023-09-01\\12-47-39_sweep1D_waittime_END_q2x90_7_times_rotate_q1' , 
                '\\2023-09-01\\12-51-27_sweep1D_waittime_END_q2x90_8_times_rotate_q1' ,                 
              ]


names = [glob.glob(datadir + x)[0]  for x in start_time]
datfiles = []
for i in range(len(names)):
    datfiles += [load_data(names[i])]

xdatalist = []
zdatalist = []
histlist = []
zdatalist_reth = []
for i in range(len(names)):

    xdata,  zdata = data1d_attr(datfiles[i],  ['ndarray'], 'su_trig1', ['ndarray'] )
    zdatalist += [  zdata ]
    xdatalist += [ xdata ]
    
    histlist += [ [datfiles[i].sensorval_S_North_trig1_set.ndarray, datfiles[i].hist_trig1.ndarray] ]
    vth = 125
    mask = histlist[i][0][0,:] < vth
    zdata_rethresh = np.zeros((histlist[i][0].shape[0],))
    for j in range(histlist[i][0].shape[0]):
        temp_var = histlist[i][1][j,:]
        zdata_rethresh[j] = np.sum(temp_var[mask])
    zdatalist_reth +=  [zdata_rethresh]
    
# zdata_newlist = []
# for line_id in range(len(names)):
#     zdata_new = hist_auto_1d(histlist[line_id][0], histlist[line_id][1], xdatalist[line_id], plot_thresholding=False )[0]
#     zdata_newlist += [zdata_new]

 

zdatalist = list(zdatalist_reth)

# zdatalist = list(zdata_newlist)
 
zavg = []
titlestr = ''
plt.figure()    
for i in range(len(names)):
# for i in [1]:
    name = names[i]
    for j in range(len(name)):
        try:
            tempstr = datetime.datetime.strptime(name[j:j+19], '%Y-%m-%d\\%H-%M-%S').strftime('%Y-%m-%d_%H-%M-%S') 
            break
        except ValueError as Err: 
            tempstr = None
            pass    
    if i!=0:
        tempstr = tempstr[-8:]
        
    zoffset = 0 
    xdata = xdatalist[i]
    zdata = zdatalist[i]
    plt.plot(xdata, zdata + zoffset, 'o-', label=tempstr, c=f'C{i}'  )
    zavg += [  np.average(zdata)  ]

# plt.legend()


print( min(zavg), max(zavg),  max(zavg)- min(zavg) ) # readout visibitity
# 0.6952418032786885

#%% Estimate readout visibility by averaging

start_time = [    
                '\\2023-09-01\\12-13-59_sweep1D_waittime_END_q1x90_0_times_rotate_q2' ,   
                '\\2023-09-01\\12-17-43_sweep1D_waittime_END_q1x90_1_times_rotate_q2' ,   
                '\\2023-09-01\\12-21-28_sweep1D_waittime_END_q1x90_2_times_rotate_q2' ,   
                '\\2023-09-01\\12-25-14_sweep1D_waittime_END_q1x90_3_times_rotate_q2' , 
                '\\2023-09-01\\12-29-01_sweep1D_waittime_END_q1x90_4_times_rotate_q2' ,   
                '\\2023-09-01\\12-32-47_sweep1D_waittime_END_q1x90_5_times_rotate_q2' ,   
                '\\2023-09-01\\12-45-45_sweep1D_waittime_END_q1x90_6_times_rotate_q2' , 
                '\\2023-09-01\\12-49-33_sweep1D_waittime_END_q1x90_7_times_rotate_q2' ,   
                '\\2023-09-01\\12-53-22_sweep1D_waittime_END_q1x90_8_times_rotate_q2' ,                 
              ]

names = [glob.glob(datadir + x)[0]  for x in start_time]
datfiles = []
for i in range(len(names)):
    datfiles += [load_data(names[i])]

xdatalist = []
zdatalist = []
histlist = []
zdatalist_reth = []
for i in range(len(names)):
    xdata,  zdata = data1d_attr(datfiles[i],  ['ndarray'], 'su_trig0', ['ndarray'] )
    zdatalist += [  zdata ]
    xdatalist += [ xdata ]
    
    histlist += [ [datfiles[i].sensorval_S_North_trig0_set.ndarray, datfiles[i].hist_trig0.ndarray] ]
    vth = 150
    mask = histlist[i][0][0,:] < vth
    zdata_rethresh = np.zeros((histlist[i][0].shape[0],))
    for j in range(histlist[i][0].shape[0]):
        temp_var = histlist[i][1][j,:]
        zdata_rethresh[j] = 1-np.sum(temp_var[mask])
    zdatalist_reth +=  [zdata_rethresh]    
    
# zdata_newlist = []
# for line_id in range(len(names)):
#     zdata_new = 1-hist_auto_1d(histlist[line_id][0], histlist[line_id][1], xdatalist[line_id], plot_thresholding=False )[0]
#     zdata_newlist += [zdata_new]



zdatalist = list(zdatalist_reth)

# zdatalist = list(zdata_newlist)

zavg = []
titlestr = ''
plt.figure()    
for i in range(len(names)):
    name = names[i]
    for j in range(len(name)):
        try:
            tempstr = datetime.datetime.strptime(name[j:j+19], '%Y-%m-%d\\%H-%M-%S').strftime('%Y-%m-%d_%H-%M-%S') 
            break
        except ValueError as Err: 
            tempstr = None
            pass    
    if i!=0:
        tempstr = tempstr[-8:]
        
    zoffset = 0 #i * 0.04
    xdata = xdatalist[i]
    zdata = zdatalist[i]
    plt.plot(xdata, zdata + zoffset, 'o-', label=tempstr, c=f'C{i}'  )
    titlestr += (tempstr + ', ')
    zavg += [  np.average(zdata)  ]
# plt.legend()
    

print( min(zavg), max(zavg) ,  max(zavg)- min(zavg) )  # readout visibitity
# 0.7952704918032786







#%%
plt.rcParams.update({'font.size':15})
datadir = os.getcwd()  

d_2on1 = dict()

# f0 = 0.033
start_time = [    
                '\\2023-09-01\\12-12-08_sweep1D_waittime_END_q2x90_0_times_rotate_q1' ,   
                '\\2023-09-01\\12-15-51_sweep1D_waittime_END_q2x90_1_times_rotate_q1' ,   
                '\\2023-09-01\\12-19-36_sweep1D_waittime_END_q2x90_2_times_rotate_q1' , 
                '\\2023-09-01\\12-23-21_sweep1D_waittime_END_q2x90_3_times_rotate_q1' , 
                '\\2023-09-01\\12-27-08_sweep1D_waittime_END_q2x90_4_times_rotate_q1' , 
                '\\2023-09-01\\12-30-54_sweep1D_waittime_END_q2x90_5_times_rotate_q1' , 
                '\\2023-09-01\\12-43-50_sweep1D_waittime_END_q2x90_6_times_rotate_q1' , 
                '\\2023-09-01\\12-47-39_sweep1D_waittime_END_q2x90_7_times_rotate_q1' , 
                '\\2023-09-01\\12-51-27_sweep1D_waittime_END_q2x90_8_times_rotate_q1' ,                 
              ]



# datfiles[0].metadata['circuit']['statements']

names = [glob.glob(datadir + x)[0]  for x in start_time]
datfiles = []
for i in range(len(names)):
    datfiles += [load_data(names[i])]

xdatalist = []
zdatalist = []
histlist = []
zdatalist_reth = []
for i in range(len(names)):
    xdata,  zdata = data1d_attr(datfiles[i],  ['ndarray'], 'su_trig0', ['ndarray'] )
    zdatalist += [  zdata ]
    xdatalist += [ xdata ]
    
    histlist += [ [datfiles[i].sensorval_S_North_trig0_set.ndarray, datfiles[i].hist_trig0.ndarray] ]
    vth = 150
    mask = histlist[i][0][0,:] < vth
    zdata_rethresh = np.zeros((histlist[i][0].shape[0],))
    for j in range(histlist[i][0].shape[0]):
        temp_var = histlist[i][1][j,:]
        zdata_rethresh[j] = 1-np.sum(temp_var[mask])
    zdatalist_reth +=  [zdata_rethresh]

 


def osc_without_decay(t, A, f, y0, phi):
    return A*np.cos(2*np.pi*t*f+phi)+y0
zdatalist = list(zdatalist_reth)
p1s = []
for i in range(len(names)):
    zdata = zdatalist[i]
    xdata = xdatalist[i]
    f0 = datfiles[i].metadata['settings']['q1']['x90']['frequency']/1e9
    bounds = [[-np.inf, 0.042, -np.inf, -np.inf], [np.inf, 0.043, np.inf, np.inf]]
    p0 = [abs(np.max(zdata)-np.min(zdata))/2, f0, np.mean(zdata), 0 ]
    _, p1 = fit_data(xdata, zdata,func=osc_without_decay,p0=p0, plot=False, return_cov=True, bounds=bounds)
    p1s += [p1]    
 

titlestr = ''
#plt.figure()    
for i in range(len(names)):
    name = names[i]
    for j in range(len(name)):
        try:
            tempstr = datetime.datetime.strptime(name[j:j+19], '%Y-%m-%d\\%H-%M-%S').strftime('%Y-%m-%d_%H-%M-%S') 
            break
        except ValueError as Err: 
            tempstr = None
            pass    
    if i!=0:
        tempstr = tempstr[-8:]
        
    zoffset = i * 0.04
    xdata = xdatalist[i]
    zdata = zdatalist[i]
    xxx = np.linspace(xdata[0], xdata[-1], (len(xdata)-1)*5+1  )
    #plt.plot(xdata*2/23.5259747581818, zdata + zoffset, 'o-', label=tempstr, c='C0'  )
    #plt.plot(xxx*2/23.5259747581818, osc_without_decay(xxx, *p1s[i] ) + zoffset, c='k' )
    d_2on1[str(i)] = dict(xdata=xdata, zdata=zdata, xxx=xxx, yyy=osc_without_decay(xxx, *p1s[i] ), p1s=p1s, 
                          fq1 =  datfiles[i].metadata['settings']['q1']['x90']['frequency'])
    titlestr += (tempstr + ', ')

    
plt.title( titlestr   )




#%%
datadir = os.getcwd()  

d_1on2 = dict()



f0 = 0.070
start_time = [    
                '\\2023-09-01\\12-13-59_sweep1D_waittime_END_q1x90_0_times_rotate_q2' ,   
                '\\2023-09-01\\12-17-43_sweep1D_waittime_END_q1x90_1_times_rotate_q2' ,   
                '\\2023-09-01\\12-21-28_sweep1D_waittime_END_q1x90_2_times_rotate_q2' ,   
                '\\2023-09-01\\12-25-14_sweep1D_waittime_END_q1x90_3_times_rotate_q2' , 
                '\\2023-09-01\\12-29-01_sweep1D_waittime_END_q1x90_4_times_rotate_q2' ,   
                '\\2023-09-01\\12-32-47_sweep1D_waittime_END_q1x90_5_times_rotate_q2' ,   
                '\\2023-09-01\\12-45-45_sweep1D_waittime_END_q1x90_6_times_rotate_q2' , 
                '\\2023-09-01\\12-49-33_sweep1D_waittime_END_q1x90_7_times_rotate_q2' ,   
                '\\2023-09-01\\12-53-22_sweep1D_waittime_END_q1x90_8_times_rotate_q2' ,                 
              ]

# datfiles[0].metadata['circuit']['statements']

names = [glob.glob(datadir + x)[0]  for x in start_time]
datfiles = []
for i in range(len(names)):
    datfiles += [load_data(names[i])]

xdatalist = []
zdatalist = []
histlist = []
zdatalist_reth = []
for i in range(len(names)):

    xdata,  zdata = data1d_attr(datfiles[i],  ['ndarray'], 'su_trig1', ['ndarray'] )
    zdatalist += [  zdata ]
    xdatalist += [ xdata ]
    
    histlist += [ [datfiles[i].sensorval_S_North_trig1_set.ndarray, datfiles[i].hist_trig1.ndarray] ]
    vth = 125
    mask = histlist[i][0][0,:] < vth
    zdata_rethresh = np.zeros((histlist[i][0].shape[0],))
    for j in range(histlist[i][0].shape[0]):
        temp_var = histlist[i][1][j,:]
        zdata_rethresh[j] = np.sum(temp_var[mask])
    zdatalist_reth +=  [zdata_rethresh]    
    
zdata_newlist = []
for line_id in range(len(names)):
    zdata_new = hist_auto_1d(histlist[line_id][0], histlist[line_id][1], xdatalist[line_id], plot_thresholding=False )[0]
    zdata_newlist += [zdata_new]



def osc_without_decay(t, A, f, y0, phi):
    return A*np.cos(2*np.pi*t*f+phi)+y0

p1s = []
for i in range(len(names)):


    zdata = zdatalist[i]
    xdata = xdatalist[i]
    f0 = datfiles[i].metadata['settings']['q2']['x90']['frequency']/1e9

    p0 = [abs(np.max(zdata)-np.min(zdata))/2, f0, np.mean(zdata), 0 ]
    _, p1 = fit_data(xdata, zdata,func=osc_without_decay,p0=p0, plot=False, return_cov=True)
    p1s += [p1]    
 

titlestr = ''
#plt.figure()    
for i in range(len(names)):
    name = names[i]
    for j in range(len(name)):
        try:
            tempstr = datetime.datetime.strptime(name[j:j+19], '%Y-%m-%d\\%H-%M-%S').strftime('%Y-%m-%d_%H-%M-%S') 
            break
        except ValueError as Err: 
            tempstr = None
            pass    
    if i!=0:
        tempstr = tempstr[-8:]
        
    zoffset = i * 0.04
    xdata = xdatalist[i]
    zdata = zdatalist[i]
    #plt.plot(xdata, zdata + zoffset, 'o-', label=tempstr, c=f'C{i}'  )
    xxx = np.linspace(xdata[0], xdata[-1], (len(xdata)-1)*5+1  )
    #plt.plot(xxx, osc_without_decay(xxx, *p1s[i] ) + zoffset, c=f'C{i}' )

    d_1on2[str(i)] = dict(xdata=xdata, zdata=zdata, xxx=xxx, yyy=osc_without_decay(xxx, *p1s[i] ), p1s=p1s, 
                          fq2 =  datfiles[i].metadata['settings']['q2']['x90']['frequency'])
    titlestr += (tempstr + ', ')
    


    
plt.title( titlestr   )


#%%


CQ1 = '#0D77BC'
CQ2 = '#DD5E27'
MRSIZE = 1.4
SCSIZE = MRSIZE**2
LW = 0.5
from mpl_toolkits.axes_grid1 import Divider, Size

fig = plt.figure( figsize=(14,8))
h = [Size.Fixed(1), Size.Fixed(1.5), Size.Fixed(1), Size.Fixed(1.5), Size.Fixed(1), Size.Fixed(1.5)]
v = [Size.Fixed(0.5), Size.Fixed(1.5), Size.Fixed(1), Size.Fixed(1.5)]

divider = Divider(fig, (0, 0, 1, 1), h, v, aspect=False)
ax11 = fig.add_axes(divider.get_position(),
                   axes_locator=divider.new_locator(nx=1, ny=1))
ax31 = fig.add_axes(divider.get_position(),
                   axes_locator=divider.new_locator(nx=3, ny=1))
ax51 = fig.add_axes(divider.get_position(),
                   axes_locator=divider.new_locator(nx=5, ny=1))

ax = ax11
waittime2phase = 2*np.pi*1e-9*d_2on1['0']['fq1'] 
for i in range(7):
    idx = str(i)
    zoffset = -i*0.05
    ax.plot(d_2on1[idx]['xdata']*waittime2phase/(np.pi), d_2on1[idx]['zdata'] + zoffset, 'o', markersize=MRSIZE, linestyle='')
    if i not in [0, ]:    
        ax.plot(d_2on1[idx]['xxx']*waittime2phase/(np.pi), d_2on1[idx]['yyy'] + zoffset, 'k-', linewidth=LW)
ax.set_ylim(0.13, 0.51)
ax.set_xticks([0,  2, 4, ])
# ax.set_yticks([0.5, 0.55, 0.6, 0.65, 0.7, 0.75, 0.8])
ax.set_yticks([0.2, 0.25, 0.3, 0.35, 0.4, 0.45, 0.5])

ax = ax31
waittime2phase = 2*np.pi*1e-9*d_1on2['0']['fq2'] 
for i in range(7):
    idx = str(i)
    zoffset = -i*0.05
    ax.plot(d_1on2[idx]['xdata']*waittime2phase/(np.pi), d_1on2[idx]['zdata'] + zoffset, 'o', markersize=MRSIZE, linestyle='')
    if i not in [0,6]:
        ax.plot(d_1on2[idx]['xxx']*waittime2phase/(np.pi), d_1on2[idx]['yyy'] + zoffset, 'k-', linewidth=LW)
ax.set_ylim(0.13, 0.51)
ax.set_xticks([0,  2, 4, 6, 8, 10, ])
# ax.set_yticks([0.5, 0.55, 0.6, 0.65, 0.7, 0.75, 0.8])
ax.set_yticks([0.2, 0.25, 0.3, 0.35, 0.4, 0.45, 0.5])

# filename = 'x90_transition_cross_talk'
# plt.savefig(filename+'.pdf')


#%%

def Rot(theta, phi, theta_rot):
    # reference: wikipedia    
    u = np.array([np.sin(theta)*np.cos(phi), np.sin(theta)*np.sin(phi), np.cos(theta)])
    
    uX = np.array([[0, -u[2], u[1]],
                   [u[2], 0, -u[0]],
                   [-u[1], u[0], 0] ])
    uXu =  u.reshape(3,1) @ u.reshape(3,1).T
    return np.cos(theta_rot) * np.eye(3) + np.sin(theta_rot) * uX + (1-np.cos(theta_rot)) * uXu

p1s = d_2on1['0']['p1s']
d_amp = np.array([np.abs(p1s[i][0]) for i in range(len(p1s))])

d_phi = np.array([p1s[i][3] for i in range(len(p1s))])

for i in range(len(p1s)):
    if p1s[i][0]<0:
        d_phi[i] += np.pi

readout_factor = 0.77
R = Rot(0.009*np.pi, 0, 0.9277395222307235*np.pi ) 


init = np.array([[0],[0],[-0.5]])

sim_amp = []
sim_phi = []
for N in range(9):
    U = np.eye(3)
    for i in range(N):
        U = R @ U
        
    x, y, z = (U @ init).reshape(-1,)
    sim_amp += [np.sqrt(x**2 + y**2)]
    sim_phi += [np.arctan2(y, x)]
    # print(f'N={N}, amp = ' + f'{np.sqrt(x**2 + y**2):.4g}'   )
    # print(f'N={N}, phi = ' + f'{np.arctan2(y, x):.4g}'   )


sim_amp = np.array(sim_amp)
sim_phi = np.array(sim_phi)

with np.printoptions(precision=3):
    print(d_amp[1::2]/readout_factor)
    print(sim_amp[1::2])
    
    print( d_phi[1::2])
    print(sim_phi[1::2]-1.9)
    
    print( d_phi[4::2])
    print(sim_phi[4::2]-1.9+2*np.pi)
#%%
s0 = np.eye(2)
sx = np.array([[0, 1],
               [1, 0]])
sy = np.array([[0, -1j],
               [1j, 0]])
sz = np.array([[1, 0],
               [0,-1]])

DEG = np.pi/180
# theta = 0.009*np.pi
theta = 1.89*DEG
# theta = 0.06589
phi = 0
qax = np.array([np.sin(theta)*np.cos(phi), 
                np.sin(theta)*np.sin(phi),
                np.cos(theta)])
qx, qy, qz = qax

# theta_rot = 34.439*   d_2on1['0']['fq1']*1e-9*   2*np.pi 
theta_rot = 6.755 *   d_2on1['0']['fq1']*1e-9*   2*np.pi 
U = s0*np.cos(theta_rot/2) + 1j*(sx*qx + sy*qy + sz*qz)*np.sin(theta_rot/2)

# theta_rot = 34.439*   d_2on1['0']['fq1']*1e-9*   2*np.pi
theta_rot = 27.684*   d_2on1['0']['fq1']*1e-9 * 0.9962099 *   2*np.pi
U_1100 = s0*np.cos(theta_rot/2) + 1j*(sz)*np.sin(theta_rot/2)

# U_1010 =  U @ np.linalg.inv(U_1100 )
U_1010 = np.linalg.inv(U_1100 ) @ U

mat = U_1010
# mat = U @ U_1100
u0 = np.real( np.trace( mat @ s0 )/2  )
ux = np.imag( np.trace( mat @ sx )/2  )
uy = np.imag( np.trace( mat @ sy )/2  )
uz = np.imag( np.trace( mat @ sz )/2  )
uvec = np.array([ux, uy, uz])
if np.sqrt(np.sum(uvec**2)) <= 1e-14:
    uvec = np.array([0,0,1])
else:
    uvec = uvec/np.sqrt(np.sum(uvec**2))
rot_angle = 2*np.arccos( u0)
gate_polar_angle = np.arctan2( np.sqrt(uvec[0]**2 + uvec[1]**2), uvec[2]   ) 

# print(gate_polar_angle, rot_angle)
print(f'quantization axis in _1010 configuration has polar angle {gate_polar_angle/DEG:.3g} degree')
print(f'q1 frequency in _1010 configuration is {rot_angle/(2*np.pi*6.755):.6} GHz.'  )


#%%



 # 'SetV 1,2, setpoint=_1100_s, wait_after=11.1865',
 # 'SetV 1,2, setpoint=_1010_s, wait_after=4.7550',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=3.3110',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=11.1865',
# total gate time 30.439 + 4 = 34.439 ns



 # 'SetV 1,2, setpoint=_1100_s, wait_after=23.5260',
 # 'SetV 1,2, setpoint=_0101_s, wait_after=3.7470',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=18.9500',
 # 'SetV 1,2, setpoint=_0101_s, wait_after=9.7700',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=9.5000',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=23.5260',
# total gate time 89.009 + 8 = 97.009 ns




#%%



from scipy.optimize import curve_fit

def rot_func(dtheta_q1, fq1, fq1_):
 # 'SetV 1,2, setpoint=_1100_s, wait_after=11.1865',
 # 'SetV 1,2, setpoint=_1010_s, wait_after=4.7550',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=3.3110',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=11.1865',
    
    theta_rot = 27.684 *   fq1 *   2*np.pi
    Uq1_1100 = s0*np.cos(theta_rot/2) + 1j*(sz)*np.sin(theta_rot/2)
    Rq1_1100 = Rot(0, 0, theta_rot)
    
    theta_rot = 6.755 *   fq1_ *   2*np.pi  
    Uq1_1010 = s0*np.cos(theta_rot/2) + 1j*(sx*np.sin(dtheta_q1)  + sz*np.cos(dtheta_q1) )*np.sin(theta_rot/2)
    Rq1_1010 = Rot(dtheta_q1, 0, theta_rot)
    Rq1 = Rq1_1100 @ Rq1_1010
    return Rq1, Uq1_1100 @ Uq1_1010
    
    
Visibility = 0.7952704918032786
def func(waittime, dtheta_q1,  phi0, 
         B0, B1, B2, B3, B4, B5, B6, B7, B8    ):

    B = [B0, B1, B2, B3, B4, B5, B6, B7, B8,]
    # waittime = 1
    # dtheta_q1 = 0.5*DEG
    fq1_1100 = d_2on1['0']['fq1']*1e-9
    fq1_1010 = fq1_1100 * 0.9962099

    Rq1 = rot_func(dtheta_q1, fq1_1100, fq1_1010 )[0]
    
    init = np.array([[0],[0],[-0.5]])
    
    sim_amp = []
    sim_phi = []
    readout = []

    for N in range(9):
        U = np.eye(3)
        for i in range(N):
            U = Rq1 @ U
            
        x, y, z = (U @ init).reshape(-1,)
        amp = np.sqrt(x**2 + y**2)
        phi = np.arctan2(y, x)
        
        sim_amp += [ amp ]
        sim_phi += [ phi ]
        # len(waittime) = 61 per single line
        readout += [ B[N] + np.array(Visibility*amp*np.cos(2*np.pi*fq1_1100*waittime[0:61] + phi + phi0))  ]
    # print(amp*np.cos(2*np.pi*fq1_1100*waittime + phi + phi0))
    return np.hstack(readout) 


xdata = np.hstack([d_2on1[str(i)]['xdata'] for i in range(9)] )
zdata = np.hstack([d_2on1[str(i)]['zdata'] for i in range(9)] )



p0 = [ 0.01, -1.9, 
      0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, ]
p1, pcov = curve_fit(func, xdata, zdata, p0=p0,  )

d_sim2on1 = {}
for i in range(9):
    d_sim2on1[str(i)] = func(xdata, *p1)[i*61:i*61+61]


plt.figure()


waittime2phase = 2*np.pi*1e-9*d_2on1['0']['fq1'] 
for i in range(9):
    idx = str(i)
    zoffset = -i*0.05
    plt.plot(d_2on1[idx]['xdata'], d_2on1[idx]['zdata'] + zoffset, 'o', markersize=MRSIZE, linestyle='')
    # if i not in [0, ]:    
    # plt.plot(d_2on1[idx]['xdata'], func(d_2on1[idx]['xdata'], *p1  ) + zoffset, 'k-', linewidth=LW)
    
    plt.plot(d_2on1[idx]['xdata'], d_sim2on1[idx] + zoffset, 'k-', linewidth=LW)


plt.rcParams.update({'font.size':10})


err_visibility = (0.05/Visibility)*p1[0]  # manually estimate the uncertainty coming from the uncertainty of the visibility
err_p10 = np.sqrt(np.sqrt(np.diag(pcov))[0]**2 + err_visibility**2)
plt.title(f'fitted oscillation assume max. visibility = {Visibility:.5g} \n' + \
          f'{p1[0]/DEG:.3g} +- {err_p10/DEG:.3g}degree')


#%%

R, Uq1 = rot_func(p1[0], d_2on1['0']['fq1']*1e-9, d_2on1['0']['fq1']*1e-9 * 0.9962099)


mat = Uq1
u0 = np.real( np.trace( mat @ s0 )/2  )
ux = np.imag( np.trace( mat @ sx )/2  )
uy = np.imag( np.trace( mat @ sy )/2  )
uz = np.imag( np.trace( mat @ sz )/2  )
uvec = np.array([ux, uy, uz])
if np.sqrt(np.sum(uvec**2)) <= 1e-14:
    uvec = np.array([0,0,1])
else:
    uvec = uvec/np.sqrt(np.sum(uvec**2))
rot_angle = 2*np.arccos( u0)
gate_polar_angle = np.arctan2( np.sqrt(uvec[0]**2 + uvec[1]**2), uvec[2]   ) 


print(f'crosstalk rotation has a polar angle {gate_polar_angle/DEG:.5g} degree')



#%%
p1s = d_1on2['0']['p1s']
d_amp = np.array([np.abs(p1s[i][0]) for i in range(len(p1s))])

d_phi = np.array([p1s[i][3] for i in range(len(p1s))])

for i in range(len(p1s)):
    if p1s[i][0]<0:
        d_phi[i] += np.pi

readout_factor = 0.7

# R = Rot(0.004*np.pi, 0, 1.35*np.pi ) 
R = Rot(0.006*np.pi, 0, 1.35*np.pi ) 

init = np.array([[0],[0],[-0.5]])

sim_amp = []
sim_phi = []
for N in range(9):
    U = np.eye(3)
    for i in range(N):
        U = R @ U
        
    x, y, z = (U @ init).reshape(-1,)
    sim_amp += [np.sqrt(x**2 + y**2)]
    sim_phi += [np.arctan2(y, x)]
    # print(f'N={N}, amp = ' + f'{np.sqrt(x**2 + y**2):.4g}'   )
    
    # print(f'N={N}, phi = ' + f'{np.arctan2(y, x):.4g}'   )
# gate time Q2 = 11.1865+11.1865+4.7550+3.3110 +2*2 = 34.439 ns
# Q1 period =  1e9/d_2on1['0']['fq1']  = 23.526
# time for _1010 state = 4.755 + 2 = 6.755 ns
# time for _1100 state = 27.684 ns

sim_amp = np.array(sim_amp)
sim_phi = np.array(sim_phi)

with np.printoptions(precision=3):
    print(d_amp/readout_factor)
    print(sim_amp)
    # print(sim_amp[1::2])
    
    # d_phi += np.array([0, 0, -1, 0, -1, 0, -2, 0, -4])*np.pi
    print( np.array([d_phi[i]   for i in [1,2,4,5,7,8] ])   )
    print( np.array([sim_phi[i]+3.7   for i in [1,2,4,5,7,8] ])  )

# print( d_phi[4::2])
# print(sim_phi[4::2]-1.9+2*np.pi)
fq2 = d_1on2['0']['fq2']*1e-9
fq2_ = fq2 * 0.987721
(24.526 + 20.95 + 10.5 + 23.526) * fq2  +  ( 5.747 + 11.77) * fq2_

#%%
dtheta_q2 = np.pi * 0.005

mat = rot_func(dtheta_q2, fq2, fq2_)[1]
u0 = np.real( np.trace( mat @ s0 )/2  )
ux = np.imag( np.trace( mat @ sx )/2  )
uy = np.imag( np.trace( mat @ sy )/2  )
uz = np.imag( np.trace( mat @ sz )/2  )
uvec = np.array([ux, uy, uz])
if np.sqrt(np.sum(uvec**2)) <= 1e-14:
    uvec = np.array([0,0,1])
else:
    uvec = uvec/np.sqrt(np.sum(uvec**2))
rot_angle = 2*np.arccos( u0)
gate_polar_angle = np.arctan2( np.sqrt(uvec[0]**2 + uvec[1]**2), uvec[2]   ) 
print(  f'{rot_angle:.3g},  ' + f'  {gate_polar_angle:.3g}'  )


#%%


from scipy.optimize import curve_fit

def rot_func(dtheta_q2, fq2, fq2_):
 # 'SetV 1,2, setpoint=_1100_s, wait_after=23.5260',
 # 'SetV 1,2, setpoint=_0101_s, wait_after=3.7470',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=18.9500',
 # 'SetV 1,2, setpoint=_0101_s, wait_after=9.7700',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=9.5000',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=23.5260',
    Uq2 = np.eye(2,dtype=complex)
    Rq2 = np.eye(3)
    
    theta_rot = 24.526 *   fq2 *   2*np.pi
    Uq2 = (s0*np.cos(theta_rot/2) + 1j*(sz)*np.sin(theta_rot/2))  @ Uq2
    Rq2 = Rot(0, 0, theta_rot) @ Rq2
      
    theta_rot = 5.747 *   fq2_ *   2*np.pi  
    Uq2 = ( s0*np.cos(theta_rot/2) + 1j*(sx*np.sin(dtheta_q2)  + sz*np.cos(dtheta_q2) )*np.sin(theta_rot/2) ) @ Uq2
    Rq2 = Rot(dtheta_q2, 0, theta_rot) @ Rq2
    
    theta_rot = 20.95 *   fq2 *   2*np.pi
    Uq2 = (s0*np.cos(theta_rot/2) + 1j*(sz)*np.sin(theta_rot/2))  @ Uq2
    Rq2 = Rot(0, 0, theta_rot) @ Rq2
    
    theta_rot = 11.77 *   fq2_ *   2*np.pi  
    Uq2 = ( s0*np.cos(theta_rot/2) + 1j*(sx*np.sin(dtheta_q2)  + sz*np.cos(dtheta_q2) )*np.sin(theta_rot/2) ) @ Uq2
    Rq2 = Rot(dtheta_q2, 0, theta_rot) @ Rq2
    
    theta_rot = 10.5 *   fq2 *   2*np.pi
    Uq2 = (s0*np.cos(theta_rot/2) + 1j*(sz)*np.sin(theta_rot/2))  @ Uq2
    Rq2 = Rot(0, 0, theta_rot) @ Rq2    
    
    theta_rot = 23.526 *   fq2 *   2*np.pi
    Uq2 = (s0*np.cos(theta_rot/2) + 1j*(sz)*np.sin(theta_rot/2))  @ Uq2
    Rq2 = Rot(0, 0, theta_rot) @ Rq2    

    return Rq2, Uq2
    
    
Visibility =  0.6952418032786885
def func(waittime, dtheta_q2,  phi0, 
         B0, B1, B2, B3, B4, B5, B6, B7, B8    ):

    B = [B0, B1, B2, B3, B4, B5, B6, B7, B8,]
    fq2_1100 = d_1on2['0']['fq2']*1e-9
    fq2_0101 = fq2_1100 * 0.987721

    Rq2 = rot_func(dtheta_q2, fq2_1100, fq2_0101 )[0]
    
    init = np.array([[0],[0],[-0.5]])
    
    sim_amp = []
    sim_phi = []
    readout = []

    for N in range(9):
        U = np.eye(3)
        for i in range(N):
            U = Rq2 @ U
            
        x, y, z = (U @ init).reshape(-1,)
        amp = np.sqrt(x**2 + y**2)
        phi = np.arctan2(y, x)
        
        sim_amp += [ amp ]
        sim_phi += [ phi ]
        # len(waittime) = 61 per single line
        readout += [ B[N] + np.array(Visibility*amp*np.cos(2*np.pi*fq2_1100*waittime[0:61] + phi + phi0))  ]
    # print(amp*np.cos(2*np.pi*fq1_1100*waittime + phi + phi0))
    return np.hstack(readout) 


xdata = np.hstack([d_1on2[str(i)]['xdata'] for i in range(9)] )
zdata = np.hstack([d_1on2[str(i)]['zdata'] for i in range(9)] )



p0 = [ 0.012, 5, 
      0.48, 0.48, 0.48, 0.48, 0.48, 0.48, 0.48, 0.48, 0.48, ]
p1, pcov = curve_fit(func, xdata, zdata, p0=p0,  )

d_sim1on2 = {}
for i in range(9):
    d_sim1on2[str(i)] = func(xdata, *p1)[i*61:i*61+61]


plt.figure()


waittime2phase = 2*np.pi*1e-9*d_1on2['0']['fq2'] 
for i in range(9):
    idx = str(i)
    zoffset = -i*0.05
    plt.plot(d_1on2[idx]['xdata'], d_1on2[idx]['zdata'] + zoffset, 'o', markersize=MRSIZE, linestyle='-')
    # if i not in [0, ]:    
    # plt.plot(d_2on1[idx]['xdata'], func(d_2on1[idx]['xdata'], *p1  ) + zoffset, 'k-', linewidth=LW)
    
    plt.plot(d_1on2[idx]['xdata'], d_sim1on2[idx] + zoffset, 'k-', linewidth=LW)


# plt.rcParams.update({'font.size':10})
# plt.title(f'fitted oscillation assume max. visibility = {Visibility:.5g} \n' + \
#           f'{p1[0]/DEG:.3g} degree')
err_visibility = (0.05/Visibility)*p1[0]  # manually estimate the uncertainty coming from the uncertainty of the visibility
err_p10 = np.sqrt(np.sqrt(np.diag(pcov))[0]**2 + err_visibility**2)
plt.title(f'fitted oscillation assume max. visibility = {Visibility:.5g} \n' + \
          f'{p1[0]/DEG:.3g} +- {err_p10/DEG:.3g}degree')

#%%

R, Uq1 = rot_func(p1[0], d_1on2['0']['fq2']*1e-9, d_1on2['0']['fq2']*1e-9 * 0.987721 )


mat = Uq1
u0 = np.real( np.trace( mat @ s0 )/2  )
ux = np.imag( np.trace( mat @ sx )/2  )
uy = np.imag( np.trace( mat @ sy )/2  )
uz = np.imag( np.trace( mat @ sz )/2  )
uvec = np.array([ux, uy, uz])
if np.sqrt(np.sum(uvec**2)) <= 1e-14:
    uvec = np.array([0,0,1])
else:
    uvec = uvec/np.sqrt(np.sum(uvec**2))
rot_angle = 2*np.arccos( u0)
gate_polar_angle = np.arctan2( np.sqrt(uvec[0]**2 + uvec[1]**2), uvec[2]   ) 


print(f'crosstalk rotation has a polar angle {gate_polar_angle/DEG:.5g} degree')


#%%
CQ1 = '#0D77BC'
CQ2 = '#DD5E27'
MRSIZE = 1.4
SCSIZE = MRSIZE**2
LW = 0.5
from mpl_toolkits.axes_grid1 import Divider, Size

fig = plt.figure( figsize=(14,8))
h = [Size.Fixed(1), Size.Fixed(1.5), Size.Fixed(1), Size.Fixed(1.5), Size.Fixed(1), Size.Fixed(1.5)]
v = [Size.Fixed(0.5), Size.Fixed(1.5), Size.Fixed(1), Size.Fixed(1.5)]

divider = Divider(fig, (0, 0, 1, 1), h, v, aspect=False)
ax11 = fig.add_axes(divider.get_position(),
                   axes_locator=divider.new_locator(nx=1, ny=1))
ax31 = fig.add_axes(divider.get_position(),
                   axes_locator=divider.new_locator(nx=3, ny=1))
ax51 = fig.add_axes(divider.get_position(),
                   axes_locator=divider.new_locator(nx=5, ny=1))

ax = ax11
waittime2phase = 2*np.pi*1e-9*d_2on1['0']['fq1'] 
for i in range(9):
    idx = str(i)
    zoffset = -i*0.05
    ax.plot(d_2on1[idx]['xdata']*waittime2phase/(np.pi), d_2on1[idx]['zdata'] + zoffset, 'o', markersize=MRSIZE, linestyle='')
    # if i not in [0, ]:    
    ax.plot(d_2on1[idx]['xdata']*waittime2phase/(np.pi), d_sim2on1[idx] + zoffset, 'k-', linewidth=LW)
ax.set_ylim(0.03, 0.51)
ax.set_xticks([0,  2, 4, ])
# ax.set_yticks([0.5, 0.55, 0.6, 0.65, 0.7, 0.75, 0.8])
ax.set_yticks([0.1, 0.15, 0.2, 0.25, 0.3, 0.35, 0.4, 0.45, 0.5])

ax = ax31
waittime2phase = 2*np.pi*1e-9*d_1on2['0']['fq2'] 
for i in range(9):
    idx = str(i)
    zoffset = -i*0.05
    ax.plot(d_1on2[idx]['xdata']*waittime2phase/(np.pi), d_1on2[idx]['zdata'] + zoffset, 'o', markersize=MRSIZE, linestyle='')
    # if i not in []:
    ax.plot(d_1on2[idx]['xdata']*waittime2phase/(np.pi), d_sim1on2[idx] + zoffset, 'k-', linewidth=LW)
ax.set_ylim(0.03, 0.51)
ax.set_xticks([0,  2, 4, 6, 8, 10, ])
# ax.set_yticks([0.5, 0.55, 0.6, 0.65, 0.7, 0.75, 0.8])
ax.set_yticks([0.1, 0.15, 0.2, 0.25, 0.3, 0.35, 0.4, 0.45, 0.5])

# filename = 'Fig8-1-b' 
# plt.savefig(filename+'.pdf')










