import os
path=str(os.getcwd())
path_notebook=str(os.getcwd())
path_notebook=path_notebook.replace('\\Fig8-2-c','')
import sys
sys.path.insert(1, path_notebook)
import helper_functions
from helper_functions import data1d_attr, data2d_attr, data_setvaribles, hist_auto_su, hist_auto_1d




import numpy as np
import matplotlib.pyplot as plt
from projects.notebook_tools.notebook_tools import get_data_from, fit_data
from matplotlib import cm
from matplotlib.colors import ListedColormap, LinearSegmentedColormap
import datetime
import qtt
import sys
import glob
from qcodes.data.data_set import load_data
# from LD400Top_v3.script_shuttling_15052023.helper_functions import data1d_attr, data2d_attr, data_setvaribles
# from notebook_tools import fit_data

datadir = os.getcwd()  
#%%
from scipy.fft import fft, fftfreq



def osc_with_decay_alpha(t, A, f, y0, phi, T2, alpha):
    return A*np.cos(2*np.pi*t*f+phi)*np.exp(-(t/T2)**alpha)+y0

def osc_with_decay(t, A, f, y0, phi, T2):
    return A*np.cos(2*np.pi*t*f+phi)*np.exp(-(t/T2)**2)+y0

def osc_without_decay(t, A, f, y0, phi):
    return A*np.cos(2*np.pi*t*f+phi)+y0

#%%
# plt.rcParams.update({'font.size':15})
d_2on1 = dict()



start_time = [     
              '\\2023-08-19\\11-02-10_sweep1D_waittime_calibration_q2x90_to_q1_phase',  # N=0
                '\\2023-08-19\\11-01-55_sweep1D_waittime_calibration_q2x90_to_q1_phase',  # N=4
                '\\2023-08-19\\11-01-40_sweep1D_waittime_calibration_q2x90_to_q1_phase',  # N=8

              ]



names = [glob.glob(datadir + x)[0]  for x in start_time]
datfiles = []
for i in range(len(names)):
    datfiles += [load_data(names[i])]

xdatalist = []
zdatalist = []
for i in range(len(names)):
    xdata,  zdata = data1d_attr(datfiles[i],  ['ndarray'], 'su10', ['ndarray'] )
    zdatalist += [  zdata ]
    xdatalist += [ xdata ]


p1s = []
for i in range(len(names)):


    zdata = zdatalist[i]
    xdata = xdatalist[i]
    zf = fft(zdata)
    xf = fftfreq(len(xdata), d=abs(xdata[1]-xdata[0])  )
    f0 = xf[np.argmax(abs(zf[1:])) + 1]    


    p0 = [abs(np.max(zdata)-np.min(zdata))/2, f0, np.mean(zdata), 0 ]
    _, p1 = fit_data(xdata, zdata,func=osc_without_decay,p0=p0, plot=False, return_cov=True)
    p1s += [p1]
    


titlestr = ''
plt.figure()    
for i in range(len(names)):
    name = names[i]
    for j in range(len(name)):
        try:
            tempstr = datetime.datetime.strptime(name[j:j+19], '%Y-%m-%d\\%H-%M-%S').strftime('%Y-%m-%d_%H-%M-%S') 
            break
        except ValueError as Err: 
            tempstr = None
            pass    
    if i!=0:
        tempstr = tempstr[-8:]
    xdata = xdatalist[i]
    zdata = zdatalist[i]
    plt.scatter(xdata, zdata, label=tempstr  )
    # plt.scatter(xdata, xdatalist[i], label=names[i][0:19)
    xxx = np.linspace(xdata[0], xdata[-1], (len(xdata)-1)*5+1  )
    plt.plot(xxx, osc_without_decay(xxx, *p1s[i] ) )

    titlestr += (tempstr + ', ')
    
    d_2on1[str(i)] = dict(xdata=xdata, zdata=zdata, xxx=xxx, yyy=osc_without_decay(xxx, *p1s[i] ), p1s=p1s, 
                          fq1 =  datfiles[i].metadata['settings']['q1']['x90']['frequency'])
    # plt.yticks([0.1, 0.9])
plt.legend()
    
plt.title( titlestr   )

#%%
# datfiles[idx].metadata['settings']['q1,q2']['v_setpoints']['_ramp_times']['_1100_s-_1010_s']

# 1e9/datfiles[0].metadata['settings']['q1']['x90']['frequency']

# = 23.735440413826453  ns

fq1_1100 = 42131091e-9
fq2_1100 = 88139057e-9
idx = 2

# [print( x  ) for x in datfiles[idx].metadata['circuit']['statements'] ]
# print( datfiles[idx].metadata['circuit']['compiled']  )

# q2 x90
 # 'SetV 1,2, setpoint=_1100_s, wait_after=11.3457',
 # 'SetV 1,2, setpoint=_1010_s, wait_after=4.8600',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=3.4200',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=11.3457',
# total time (with ramps)   34.9714 ns

# N=4
# SetV 1,2, setpoint=_1100_s, wait_after=4.3080
# q2x90  ^ 4
# SetV 1,2, setpoint=_1100_s, wait_after=22.0580
# 34.9714*4+4.3080+22.058 = 166.2516
# 166.2516 % 23.735440413826453 = 0.10351710321482699 ns -> 0.026*4

# N=8
# SetV 1,2, setpoint=_1100_s, wait_after=4.3080
# q2x90  ^ 8
# SetV 1,2, setpoint=_1100_s, wait_after=0.9530
# 34.9714*8+4.3080+0.9530 = 285.0322
# 285.0322 % 23.735440413826453 = 0.20691503408255585  -> 0.026*8


#%%

d_1on2 = dict()

start_time = [    
              '\\2023-08-19\\11-09-55_sweep1D_waittime_calibration_q1x90_to_q2_phase',  # N=0
              '\\2023-08-19\\11-10-09_sweep1D_waittime_calibration_q1x90_to_q2_phase',  # N=4
              '\\2023-08-19\\11-10-22_sweep1D_waittime_calibration_q1x90_to_q2_phase',  # N=8
              ]



names = [glob.glob(datadir + x)[0]  for x in start_time]
datfiles = []
for i in range(len(names)):
    datfiles += [load_data(names[i])]

xdatalist = []
zdatalist = []
for i in range(len(names)):
    xdata,  zdata = data1d_attr(datfiles[i],  ['ndarray'], 'su01', ['ndarray'] )
    zdatalist += [  zdata ]
    xdatalist += [ xdata ]


p1s = []
for i in range(len(names)):


    zdata = zdatalist[i]
    xdata = xdatalist[i]
    zf = fft(zdata)
    xf = fftfreq(len(xdata), d=abs(xdata[1]-xdata[0])  )
    f0 = xf[np.argmax(abs(zf[1:])) + 1]    


    p0 = [abs(np.max(zdata)-np.min(zdata))/2, f0, np.mean(zdata), 0 ]
    _, p1 = fit_data(xdata, zdata,func=osc_without_decay,p0=p0, plot=False, return_cov=True)
    p1s += [p1]



titlestr = ''
plt.figure()    
for i in range(len(names)):
    name = names[i]
    for j in range(len(name)):
        try:
            tempstr = datetime.datetime.strptime(name[j:j+19], '%Y-%m-%d\\%H-%M-%S').strftime('%Y-%m-%d_%H-%M-%S') 
            break
        except ValueError as Err: 
            tempstr = None
            pass    
    if i!=0:
        tempstr = tempstr[-8:]
    xdata = xdatalist[i]
    zdata = zdatalist[i]
    plt.scatter(xdata, zdata, label=tempstr  )
    # plt.scatter(xdata, xdatalist[i], label=names[i][0:19)
    xxx = np.linspace(xdata[0], xdata[-1], (len(xdata)-1)*5+1  )
    plt.plot(xxx, osc_without_decay(xxx, *p1s[i] ) )
    
    d_1on2[str(i)] = dict(xdata=xdata, zdata=zdata, xxx=xxx, yyy=osc_without_decay(xxx, *p1s[i] ), p1s=p1s, 
                          fq2 =  datfiles[i].metadata['settings']['q2']['x90']['frequency'])
    
    titlestr += (tempstr + ', ')
plt.legend()
    
plt.title( titlestr   )
#%%
# datfiles[idx].metadata['settings']['q1,q2']['v_setpoints']['_ramp_times']['_1100_s-_1010_s']

# 1e9/datfiles[0].metadata['settings']['q2']['x90']['frequency']
# = 11.34570795328568  ns
    
# idx = 2

# [print( x  ) for x in datfiles[idx].metadata['circuit']['statements'] ]
# print( datfiles[idx].metadata['circuit']['compiled']  )

# q1 x90
 # 'SetV 1,2, setpoint=_1100_s, wait_after=23.7354',
 # 'SetV 1,2, setpoint=_0101_s, wait_after=3.7470',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=19.3000',
 # 'SetV 1,2, setpoint=_0101_s, wait_after=10.1700',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=9.5000',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=23.7354',
# total time (with ramps)   98.1778 ns

# N=4
# SetV 1,2, setpoint=_1100_s, wait_after=12.5260
# q2x90  ^ 4
# SetV 1,2, setpoint=_1100_s, wait_after=4.0490
# 98.1778*4+12.5260+4.0490 = 409.2862
# 409.2862 % 11.34570795328568 = 0.8407136817155063 ns

# N=8
# SetV 1,2, setpoint=_1100_s, wait_after=12.5260
# q2x90  ^ 8
# SetV 1,2, setpoint=_1100_s, wait_after=9.2770
# 98.1778*8+12.5260+9.2770 = 807.2254
# 807.2254 % 11.34570795328568 = 1.680135
#%%
CQ1 = '#0D77BC'
CQ2 = '#DD5E27'
MRSIZE = 2
SCSIZE = MRSIZE**2
LW = 0.5
from mpl_toolkits.axes_grid1 import Divider, Size

fig = plt.figure( figsize=(14,8))
h = [Size.Fixed(1), Size.Fixed(1.5), Size.Fixed(1), Size.Fixed(1.5), Size.Fixed(1), Size.Fixed(1.5)]
v = [Size.Fixed(0.5), Size.Fixed(1.5), Size.Fixed(1), Size.Fixed(1.5)]

divider = Divider(fig, (0, 0, 1, 1), h, v, aspect=False)
ax11 = fig.add_axes(divider.get_position(),
                   axes_locator=divider.new_locator(nx=1, ny=1))
ax31 = fig.add_axes(divider.get_position(),
                   axes_locator=divider.new_locator(nx=3, ny=1))
ax51 = fig.add_axes(divider.get_position(),
                   axes_locator=divider.new_locator(nx=5, ny=1))

ax = ax11
waittime2phase = 2*np.pi*1e-9*d_2on1['0']['fq1'] 
for i in range(3):
    zoffset = -i*0.2
    idx = str(i)
    ax.plot(d_2on1[idx]['xdata']*waittime2phase/(np.pi), d_2on1[idx]['zdata'] + zoffset, 'o', markersize=MRSIZE, linestyle='')
    ax.plot(d_2on1[idx]['xxx']*waittime2phase/(np.pi), d_2on1[idx]['yyy'] + zoffset, 'k-', linewidth=LW)
ax.set_xticks([0, 1, 2])
ax.set_yticks([-0.3, 0.3, 0.9])

ax = ax31
waittime2phase = 2*np.pi*1e-9*d_1on2['0']['fq2'] 
for i in range(3):
    zoffset = -i*0.2
    idx = str(i)
    ax.plot(d_1on2[idx]['xdata']*waittime2phase/(np.pi), d_1on2[idx]['zdata'] + zoffset, 'o', markersize=MRSIZE, linestyle='')
    ax.plot(d_1on2[idx]['xxx']*waittime2phase/(np.pi), d_1on2[idx]['yyy'] + zoffset, 'k-', linewidth=LW)
ax.set_xticks([0, 1, 2])
ax.set_yticks([-0.3, 0.3,  0.9])

#filename = 'Fig8-2-c'
#plt.savefig(filename+'.pdf')



#%%
fq1_1100 = 42131091e-9

tramp = 2
fq1_1010 = fq1_1100 - fq1_1100*0.026/(tramp + 4.86)
# fq1_1010 = 0.04197141048017493
# fq1_1010/fq1_1100 = 0.9962099

#idx = 2
# [print( x  ) for x in datfiles[idx].metadata['circuit']['statements'] ]
# print( datfiles[idx].metadata['circuit']['compiled']  )

# q2 x90
 # 'SetV 1,2, setpoint=_1100_s, wait_after=11.3457',
 # 'SetV 1,2, setpoint=_1010_s, wait_after=4.8600',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=3.4200',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=11.3457',
# total time (with ramps)   34.9714 ns
# _1100_s: 28.1114 ns, fq1 = fq1_1100
# _1010_s: 6.86 ns, fq1 = fq1_1010 = 


fq2_1100 = 88139057e-9

tramp = 2
fq2_0101 = fq2_1100 - fq2_1100*0.22/(tramp*2 + 3.747 + 10.17)
# fq2_0101 = 0.08705681150466038
# fq2_0101/fq2_1100 = 0.987721

# q1 x90
 # 'SetV 1,2, setpoint=_1100_s, wait_after=23.7354',
 # 'SetV 1,2, setpoint=_0101_s, wait_after=3.7470',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=19.3000',
 # 'SetV 1,2, setpoint=_0101_s, wait_after=10.1700',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=9.5000',
 # 'SetV 1,2, setpoint=_1100_s, wait_after=23.7354',
# total time (with ramps)   98.1778 ns














